#include <stdio.h>

#define SIZE 10 // deve essere almeno 1

// == dichiarazione funzioni ==================================================
void leggi(int[], int);
int minimo(int [], int);
int massimo(int [], int);
double media(int[], int);
int moda(int[], int);
double mediana(int[], int[], int);
void ordina(int[], int[], int);

// == definizione funzioni ====================================================

int main(void) {
  int a[SIZE]; // array con i valori inseriti
  int b[SIZE]; // array di supporto per non modificare l'array a
  int i;

  leggi(a, SIZE);

  printf("Valori inseriti: [ ");
  for (i = 0; i < SIZE; i++) {
    printf("%i ", a[i]);
  }
  printf(" ]\n");

  printf("Il minimo e': %i\n", minimo(a, SIZE));  
  printf("Il massimo e': %i\n", massimo(a, SIZE));
  printf("La media e': %2lf\n", media(a, SIZE));
  printf("La moda e': %i\n", moda(a, SIZE ));
  printf("La mediana e': %lf\n", mediana(a, b, SIZE));
}

/* Funzione che legge size elementi e li memorizza nell'array a.
 */
void leggi(int a[], int size) {
  int i = 0;
  int n;

  do{
    printf("Numero %i: ", i+1);
    scanf("%i", &n);
    if(n >= 0) {
      a[i] = n;
      i++;
    }
  } while(i < size);
}

/* Funzione che calcola il minimo degli elementi nell'array a.
 */
int minimo(int a[], int size) {
  int i;
  int min = a[0];

  for (i = 1; i < size; i++)
    if (a[i] < min)
      min = a[i];
      
  return min;
}

/* Funzione che calcola il massimo degli elementi nell'array a.
 */
int massimo(int a[], int size) {
  int i;
  int max = a[0];

  for (i = 1; i < size; i++)
    if (a[i] > max)
      max = a[i];
      
  return max;
}

/* Funzione che calcola la media degli elementi in a.
 */
double media(int a[], int size) {
  int i, s = 0;

  for (i = 0; i < size; i++)
    s += a[i];
  return (double) s / size;
}

/* Funzione che calcola la moda degli elementi in a.
 */
int moda(int a[], int size) {
  int i, j;
  int moda;
  int frequenza_moda = 0;
  int frequenza;

  for (i = 0; i < size; i++) {
    frequenza = 0;
    for (j = 0; j < size; j++)
      if (a[i] == a[j])
        frequenza++;   // incrementiamo la frequenza del valore corrente
    if (frequenza > frequenza_moda) {
      moda = a[i];
      frequenza_moda = frequenza;
    }
  }
  
  return moda;
}

/* Funzione che calcola la moda degli elementi in a.
 * Usa b come array di supporto per non modificare a.
 */
double mediana(int a[], int b[], int size) {
  int n;
  ordina(a, b, size);
  
  // l'array b e' ordinato
  if (size % 2 == 0) {
    n = size / 2;
    return (b[n-1] + b[n]) / 2.0; // n-1 perchè gli indici partono da 0
  } else {
    n = ( size + 1 ) / 2;
    return b[n-1];  // n-1 perchè gli indici partono da 0
  }  
}

/* Funzione che copia gli elementi di a in b e ordina b,
 * senza modificare a.
 * Implementazione di min_sort.
 */
void ordina(int a[], int b[], int size) {
  int i;       // limite delle posizioni ordinate
  int j;       // indice per la ricerca del minimo
  int min_pos; // posizione del minimo
  int tmp;     // variabile temporanea per lo scambio

  // copiamo i valori di a in b
  for (i = 0; i < size; i++)
    b[i] = a[i];  

  for (i = 0; i < size - 1; i++) {
    // cerchiamo il minimo
    min_pos = i;
    for (j = i + 1; j < size; j++)
      if (b[j] < b[min_pos])
        min_pos = j;
    //scambiamo
    tmp = b[i];
    b[i] = b[min_pos];
    b[min_pos] = tmp;
  }
}
