#include <stdio.h>

#define SIZE 10

/* Funzione che legge size elementi e li memorizza nell'array a.
 */
void leggi(int a[], int size) {
	int i;

	for (i = 0; i < size; i++)
		scanf("%i", &a[i]);
}

/* Funzione che stampa gli elementi dell'array a.
 */
void stampa(int a[], int size) {
  int i;
  
  printf("[ ");
  for (i = 0; i < size; i++)
    printf("%i ", a[i]);
  printf(" ]\n");
}

/* Funzione che divide gli elementi dell'array:
 * tutti i dispari nella prima parte
 * tutti i pari nella seconda.
 */
void partiziona(int a[], int size) {
	int d = 0; // scorre i dispari e parte dall'inizio
	int p = size - 1; // scorre i pari e parte dal fondo
	int tmp;
	
	// Nel ciclo manteniamo questa proprieta' invariante:
	// da 0 a (d - 1) abbiamo elementi dispari;
	// da (p + 1) a (size - 1) abbiamo elementi pari.
	// Partiamo con d = 0 e p = size - 1.
	// Facciamo convergere d verso p.
	while (d < p) {
	  while (a[d] % 2 == 1) // avanziamo con d finche' troviamo dispari
	    d++; 
	  while (a[p] % 2 == 0) // indietreggiamo con p finche' troviamo pari
	    p--; 
	  if (d < p) { // scambiamo il pari con il dispari, entrambi finiscono nella giusta posizione
			tmp = a[p];
			a[p] = a[d];
			a[d] = tmp;
	  }
	}
}

int main(void) {
  int a[SIZE];
  int i;

	printf("Inserire %d valori interi: ", SIZE);
  leggi(a, SIZE);
	partiziona(a, SIZE);
	printf("Ecco i valori raggruppati: ");
	stampa(a, SIZE);
	
	return 0;
}
